! Program to convert grid data from PLOT3D format to Snas3D format.
!
! (c) CFD Consulting & Analysis, www.cfd-ca.de

program Plt3dSnas3d
  implicit none
  character(80) :: fnplt, fnsnas
  integer :: i, m, nblocks, nmax
  integer :: ni(10), nj(10), nk(10)
  real*8, allocatable :: x(:), y(:), z(:)

  print*,'File in PLOT3D format:'
  read(*, '(a80)') fnplt
  print*,'File in Snas3D format:'
  read(*, '(a80)') fnsnas

  open(10, file=fnplt , form='formatted', status='old')
  open(20, file=fnsnas, form='formatted', status='unknown')
  read(10, *) nblocks
  read(10, *) (ni(m), nj(m), nk(m), m=1,nblocks)

  write(20, *) 0.0 ! initial time

  do m=1,nblocks
    nmax = ni(m)*nj(m)*nk(m)
    allocate(x(nmax))
    allocate(y(nmax))
    allocate(z(nmax))
    read(10, *) (x(i), i=1,nmax), &
                (y(i), i=1,nmax), &
                (z(i), i=1,nmax)

    ! scaling for Onera M6 wing
    !do i=1,nmax
    !  x(i) = x(i)*1.1963
    !  y(i) = y(i)*1.1963
    !  z(i) = z(i)*1.1963
    !enddo

    write(20, *) m, ni(m)-1, nj(m)-1, nk(m)-1
    write(20, *) (x(i), i=1,nmax), &
                 (y(i), i=1,nmax), &
                 (z(i), i=1,nmax)

    deallocate(x)
    deallocate(y)
    deallocate(z)
  enddo

  close(10)
  close(20)

end program Plt3dSnas3d
